# Contributing to OB-USP-Agent

**First:** if you're unsure or afraid of _anything_, just ask or submit the issue anyways. You won't be yelled at for giving your best effort.  The worst that can happen is that you'll be politely asked to change something. We appreciate any sort of contributions, and don't want a wall of rules to get in the way of that.

## Getting Started
### Some Ways to Contribute
* Report potential bugs.
* Improve our guides and documentation. OB-USP-Agents's [QUICK_START_GUIDE](https://github.com/BroadbandForum/obuspa/blob/master/QUICK_START_GUIDE.md) is deployed from this repo.
* Respond to questions about usage on the issue tracker or mailing list.

### Reporting an Issue:
>Note: Issues on GitHub for OB-USP-Agent are intended to be related to bugs and integration questions. 

* Make sure you test against the latest released version. It is possible we already fixed the bug you're experiencing. However, if you are on an older version of OB-USP-Agent and feel the issue is critical, do let us know.

* Check existing issues (both open and closed) to make sure it has not been reported previously.

* Provide a reproducible test case. If a contributor can't reproduce an issue, then it dramatically lowers the chances it'll get fixed.

* Aim to respond promptly to any questions made by the OB-USP-Agent team on your issue. Stale issues will be closed.

## Building OB-USP-Agent

For build instructions, please refer to [QUICK_START_GUIDE](https://github.com/BroadbandForum/obuspa/blob/master/QUICK_START_GUIDE.md).

## Contributor License Agreement

Any company or individual interested in participating in this open source project must sign a Contributor License Agreement (more details [here](https://wiki.broadband-forum.org/pages/viewpage.action?pageId=87557395)).

