#!/bin/bash

source ./gitlab-ci/shared.sh
date +%s > timestamp.log

# compile and install obuspa
install_obuspa

supervisorctl update
[ -f "/tmp/usp.db" ] && rm -f /tmp/usp.db

supervisorctl restart all
echo "wait for usp.raw"
ubus wait_for usp.raw
echo "wait for obuspa to start"
wait_for_obuspa
check_ret
supervisorctl status all

echo "## Running obuspa test controller STOMP based tests"
/usr/local/bin/obuspa_test -p -v 4 -f /tmp/test_usp.db -r "test/controller_default_reset.txt" -x "test/ctrl_stomp_example.txt" -l "controller-output.log"
check_ret

supervisorctl stop all
echo "## Check for memory leak"
grep -q "Leak_DefinitelyLost" memory-report.xml
if [ "$?" -eq 0 ]; then
	echo "Leak detected, check memory-report"
	exit 1
fi

echo "PASS: All test pass"
