#!/bin/bash

source ./gitlab-ci/shared.sh
date +%s > timestamp.log

# compile and install obuspa
install_obuspa

exec_cmd /etc/init.d/rabbitmq-server stop
exec_cmd mosquitto -d
supervisorctl update
[ -f "/tmp/usp.db" ] && rm -f /tmp/usp.db

exec_cmd ubus wait_for usp.raw
supervisorctl status all
supervisorctl stop obuspa
sleep 1

echo "## Running mqtt tests"
./gitlab-ci/run_mqtt_test.sh 
tap-junit --suite "Shell based mqtt mtp verification" --input ./validate_result.log --output report
check_ret

supervisorctl stop all

echo "PASS: All test pass"
